package mutations

import (
	gql "github.com/llehouerou/go-graphql-client"
	"github.com/shopspring/decimal"

	"git.lehouerou.net/laurent/sorare/graphql"
)

type prepareBidInput struct {
	AuctionId      gql.ID          `json:"auctionId"`
	Amount         decimal.Decimal `json:"amount"`
	SettlementInfo SettlementInfo  `json:"settlementInfo"`
}

type PrepareBidParams struct {
	Input prepareBidInput `graphql:"input"`
}

func (m *Mutations) newPrepareBidMutation() *graphql.Mutation[AuthorizationPayload, PrepareBidParams] {
	return graphql.NewMutation[AuthorizationPayload, PrepareBidParams](m.c, "prepareBid")
}
